/* CONTENTS
   Owner:       Copyright 1991 The Ohio State University,
                Integrated Chameleon Architecture
   Module:      types.h,v
   Purpose:     ITT (insert tag tool) global definitions

   Programmer:  Julie Ann Barnes
   Reviewer:    
   Revision:    1.4
   Date:        1993/04/19 17:10:53

NOTE:
   AVAIL can be:
	HIDDEN for internal use only
	EXPORT for internal and external use

   Functions Index:
   AVAIL   NAME DEPENDS ON INTERNALLY      EXTERNALLY
   -----   ----            ----------      ----------

*/

/* HISTORY
   types.h,v
 * Revision 1.4  1993/04/19  17:10:53  ware
 * Merged John Boyds changes.
 *
 * Revision 1.3  92/03/16  13:54:08  ware
 * Make titles consistent.  Fix some consistency problems.
 * 
 * Revision 1.2  1992/01/02  23:38:08  cso
 * Upgraded to the Xica widget set from Xlwh.  Using Message boxes
 * instead of the alert shells, and the new file dialog.
 *
 * Revision 1.1.1.3  1991/10/04  20:19:03  jbm
 * First HaL mods to ICA
 *
*/

typedef enum ContentType
{
   Mixed = 0,
   Tags  = 1,
   Data  = 2
} Content;

typedef struct ContainerType
{
   String
      str;
   Widget
      w;
   struct ContainerType
      *next,
      *prev;
} Container;
   
typedef struct EntryType
{
   String
      tag;
   Boolean
      start,
      end,
      nullflag;
   Content
      type;
   int
      priority;
   Widget
      tagw,
      boolform;
   Container
      *cptr;
   struct EntryType
      *next,
      *prev;
} Entry;

