/* CONTENTS */
/* Owner:       Copyright 1990 The Ohio State University, */
/*              Integrated Chameleon Architecture */
/* Module:      rcomptoken.l,v */
/* Purpose:     Contains all of the token patterns for a .rsf specification. */
/* Programmer:  Julie Barnes */
/* Reviewer:     */
/* Revision:    1.3 */
/* Date:        1993/04/19 17:12:16 */

/* HISTORY */
/* Revision 1.2 92/10/20  jbarnes
 * Added optional IMPORT clause.
 */

/*Revision 1.1  90/10/05  13:18:58  cso */
/*Initial revision */

/* Lex specification for the retag specification language */
/* compiler.                                              */
/*                                                        */
/* Copyright 1990. The Ohio State University.             */

%a 10000
%o 15000

%{
#include "rcomp.h"

extern char *makestr();

int
   linecount;
%}


%%
"DATA ALPHABET:"|"TEXT ALPHABET:"	{
	 return(DATACHAR);
	}

"TAG ALPHABET:"|"RESERVED CHARACTERS:"	{
	 return(TAGCHAR);
	}

"AMBIGUOUS ALPHABET:"|"SPECIAL CHARACTERS:"	{
	 return(AMBIGCHAR);
	}

"SPECIAL SYMBOLS:\n"	{
	 linecount++;
	 return(SYMBOL);
	}

"PROCESSING INSTRUCTIONS:\n"|"NONSYMBOLS:\n"		{
	 linecount++;
	 return(PROCIN);
	}

"IMPLICIT TAGS:\n"|"SEGMENTING TAGS:\n"	{
	 linecount++;
	 return(IMPTAG);
	}

"EXPLICIT TAGS:\n"	{
	 linecount++;
	 return(EXPTAG);
	}

"DELIMITING TAGS:\n"	{
	 linecount++;
	 return(DELTAG);
	}

"SEPARATOR TAGS:\n"	{
	 linecount++;
	 return(SEPTAG);
	}

"\t:START:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: START\n"); 
#endif
	 return(START);
	}

"\t:END:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: END\n"); 
#endif
	 return(END);
	}

"\t:IN:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: IN\n"); 
#endif
	 return(IN);
	}

"\t:NEST:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: IN\n"); 
#endif
	 return(NEST);
	}

"\t:DEFINES:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: DEFINE\n");  
#endif
	 return(DEFINE);
	}

"\t:IMPORT:"[ ]?	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: IMPORT\n");  
#endif
	 return(IMPORT);
	}

\n	{
	 linecount++;
	 return(LINEFEED);
	}

\t	{
	}

[ a-zA-Z0-9!@#$%\^&*()\-_=+\\|\[\]{};:'"`~,.<>/?]+	{
#ifdef DEBUG
	 fprintf(stderr, "RCOMP.LEX: STRING [%s]\n", yytext); 
#endif
	 yylval.trans = (char *) makestr(yytext);
	 return(STRING);
	}

%%

void
yyerror(errorstr)

char
   *errorstr;

{
   fprintf(stderr, "Error [%s] at or before [%s] on line [%5d]\n",
	   errorstr, yytext, linecount);
   return;
}

